from curio import Kernel, new_task, run_server


async def echo_handler(client, addr):
    print('Connection from', addr)
    reader, writer = client.make_streams()
    async with reader, writer:
        while True:
            data = await reader.read()
            if not data:
                break
            await writer.write(data)
    await client.close()
    print('Connection closed')

if __name__ == '__main__':
    kernel = Kernel()
    kernel.run(run_server('', 25000, echo_handler))
